Skip to main content

Overview

Seam provides a universal API to connect and control many brands of locks. This guide provides a rapid introduction to connecting and controlling your Salto locks using the Seam API. To learn more about other device brands supported by the Seam API, such as Yale, Schlage, and August, head over to our integration page. Note that Salto offers multiple lines of products: Salto Space, Salto KS, and Salto Nebula. This guide is specifically for Salto KS. Salto Space is an on-prem system that is offline. Salto Nebula is not yet fully available as of this writing.

1 — Install Seam SDK

Seam provides client libraries for many languages, such as JavaScript, Python, Ruby, PHP, and others, as well as a Postman collection and OpenAPI spec.
npm i seam
Once installed, sign-up for Seam to get your API key, and export it as an environment variable:
$ export SEAM_API_KEY=seam_test2ZTo_0mEYQW2TvNDCxG5Atpj85Ffw
This guide uses a Sandbox Workspace. Only virtual devices can be connected. If you need to connect a real Salto site, use a non-sandbox workspace and API key.
To control your Salto locks via the Seam API, you must first authorize your Seam workspace against your Salto KS account. To do so, Seam provides Connect Webviews: pre-built UX flows that walk you through authorizing your application to control your Salto sites.

Create a Connect Webview

Code:
import { Seam } from 'seam'

const seam = new Seam() // Seam automatically uses your exported SEAM_API_KEY.

const connectWebview = await seam.connectWebviews.create({
  accepted_providers: ['salto_ks'],
})

console.log(connectWebview.login_successful) // false

// Use the returned Connect Webview URL to display
// the Connect Webview authorization flow to your user.
console.log(connectWebview.url)
Output:
false
https://connect.getseam.com/connect_webviews/view?connect_webview_id=12345678-1234-1234-1234-123456789012&auth_token=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

Authorize Your Workspace

Navigate to the URL returned by the Webview object. Since you are using a sandbox workspace, complete the login flow by entering the Salto sandbox test accounts credentials below:
During the authorization process, Seam adds an admin user to your Salto KS site. Do not suspend or remove this Seam Integration admin user.
Confirm the Connect Webview was successful by querying its status:
const updatedWebview = await seam.connectWebviews.get(
  connectWebview.connect_webview_id,
)

console.log(updatedWebview.login_successful) // true

3 — Retrieve Salto Devices

After a Salto account is linked with Seam, you can retrieve devices for this Salto account. The Seam API exposes most of the device’s properties such as battery level.
const allLocks = await seam.locks.list()

const someLock = allLocks[0]

console.log(someLock.properties.online) // true
console.log(someLock.properties.locked) // true

console.log(someLock)
/_
{
"device_id": "681bf7bc-e7c6-48e6-acfe-6dbabd0615c5",
"device_type": "salto_lock",
"capabilities_supported": [
"access_code",
"lock"
],
"properties": {
"locked": true,
"online": true,
"battery_level": 1,
"salto_metadata": {
"model": "wall_reader_pin",
"lock_id": "lock_2",
"lock_type": "wall_reader_pin",
"locked_state": "locked",
"battery_level": "fresh",
"customer_reference": "BACK DOOR"
},
"has_direct_power": true,
"max_active_codes_supported": 100,
"supported_code_lengths": [
6
],
"name": "BACK DOOR"
},
"location": null,
"connected_account_id": "690dead6-e176-4f25-930b-9aef7c7137ad",
"workspace_id": "d7418ff3-a476-4f48-9a4b-211d1d21a03d",
"created_at": "2023-02-08T22:14:09.921Z",
"errors": [],
"warnings": []
}
_/

4 — Locking & Unlocking a Door

Next, you can perform the basic action of locking and unlocking a door.
Note that Salto KS disables this functionality by default and requires a special pass-through waiver via Seam. Please contact Seam to configure your IQ hubs to enable this functionality.
POST /locks/lock_door See the API Reference for details.

Unlock a door

POST https://connect.getseam.com/locks/unlock_door

Request Body

NameTypeDescription
device_idString
// lock the door
await seam.locks.lockDoor(someLock.device_id)
const updatedLock = await seam.locks.get(someLock.device_id)
console.log(updatedLock.properties.locked) // true

// unlock the door
await seam.locks.unlockDoor(someLock.device_id)
updatedLock = await seam.locks.get(someLock.device_id)
console.log(updatedLock.properties.locked) // false

5 — Setting Access Code on Salto Lock

Some Salto locks and access points will have a keypad available to program access codes. These codes can then be entered to unlock the door. The Seam API makes it easy to program both ongoing codes and timebound codes on an Salto lock. You can find out more about Salto lock access code in our core concept section on access codes.
Salto does not let you specify a code for an access code. Instead Salto generates a 6-digit code, which the Seam API returns.
// create an ongoing code
await seam.accessCodes.create({
  device_id: someLock.device_id,
  name: 'Personal Access Code',
})

// create a timebound code
await seam.accessCodes.create({
device_id: someLock.device_id,
name: 'My Temp Access Code',
starts_at: '2028-11-12T19:23:42+0000',
ends_at: '2028-11-13T19:23:42+0000',
})

// use a device_id as the "device_id" parameter
await seam.accessCodes.list({
device_id: someLock.device_id,
})

/_
[
{
access_code_id: '631a3a30-3fa7-462a-b3bc-65528ccf8765',
device_id: '681bf7bc-e7c6-48e6-acfe-6dbabd0615c5',
name: 'My Temp Access Code',
code: null,
is_waiting_for_code_assignment: true,
common_code_key: null,
type: 'time_bound',
status: 'unset',
starts_at: '2028-08-12T19:24:00.000Z',
ends_at: '2028-08-13T19:24:00.000Z',
created_at: '2023-02-08T23:28:57.061Z',
errors: [],
warnings: []
},
{
access_code_id: '774986f8-5fad-4911-a4fb-e5a2ef9f15bd',
device_id: '681bf7bc-e7c6-48e6-acfe-6dbabd0615c5',
name: 'Personal Access Code',
code: '10542',
common_code_key: null,
type: 'ongoing',
status: 'set',
created_at: '2023-02-08T23:10:54.096Z',
errors: [],
warnings: []
},
]
_/

Next Steps

Now that you’ve completed this guide, you can try to connect a real Salto device. To do so, make sure to switch to a non-sandbox workspace and API key as real devices cannot be connected to sandbox workspaces. In addition, if you’d like to explore other aspects of Seam, here is a list of helpful resources: If you have any questions or want to report an issue, email us at support@seam.co.